<template>
  <div class="container" id="detail-table">
    <div class="total-number">{{ $t("message.statistics.totalNumber") }}: <span class="total-sum">{{Catalogues_Sum.toLocaleString('fi')}}</span></div>
    <table class="table table-hover table-responsive">
              <thead id="sticky"> <!-- v-sticky sticky-side="top" id="sticky" -->
                <tr>
                  <th v-on:click="sortTable(name)" class="table-img">
                    <span class="hide">{{name}} </span>
                    {{ $t("message.statistics.tableHead.country") }}
                  </th>
                  <th v-on:click="sortTable(name)" class="table-name">
                    <span class="hide">{{name}} </span>
                    <span :class="{ 'active': sortColumn === name }"> {{ $t("message.statistics.tableHead.name") }} </span>
                      &nbsp;
                      <span :class="{ 'up': sortColumn === name & ascending === true }"></span>
                      <span :class="{ 'down': sortColumn === name & ascending === false}"></span>
                  </th>
                  <th class="table-trend">
                    {{ $t("message.statistics.tableHead.trend") }}
                  </th>
                  <th v-on:click="sortTable(CountryCount)" class="table-percent">
                    <span class="hide">{{CountryCount}} </span>
                    <span :class="{ 'active': sortColumn === CountryCount }"> % </span>
                      &nbsp;
                      <span :class="{ 'up': sortColumn === CountryCount & ascending === true }"></span>
                      <span :class="{ 'down': sortColumn === CountryCount & ascending === false}"></span>
                  </th>
                  <th v-on:click="sortTable(CountryCount)" class="table-number">
                     <span class="hide">{{CountryCount}} </span>
                    {{ $t("message.statistics.tableHead.numberOfDatasets") }}
                  </th>
                  <!-- <th class="table-updated">
                    Updated
                  </th> -->
                </tr>
              </thead>
              <tbody>
              <div v-if="this.loading === true" class="lds-ring" id="spinner-overview"><div></div><div></div><div></div><div></div></div>
              <!-- eslint-disable-next-line  -->
                <tr v-for="(row, index) in Catalogues">
                   <td class="row-img">
                      <div v-if="row.name === 'Czechia' "> <img src="../assets/img/flags/cz.png" width="30px" class="flag-icon">  </div>
                      <div v-else-if="row.name === 'Estonia' "> <img src="../assets/img/flags/ee.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Spain' "> <img src="../assets/img/flags/es.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Croatia' "> <img src="../assets/img/flags/hr.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Poland' "> <img src="../assets/img/flags/pl.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Denmark' "> <img src="../assets/img/flags/dk.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Greece' "> <img src="../assets/img/flags/gr.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Ireland' "> <img src="../assets/img/flags/ie.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Netherlands' "> <img src="../assets/img/flags/nl.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Finland' "> <img src="../assets/img/flags/fi.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Germany' "> <img src="../assets/img/flags/de.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Hungary' "> <img src="../assets/img/flags/hu.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'France' "> <img src="../assets/img/flags/fr.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Sweden' "> <img src="../assets/img/flags/se.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Liechtenstein' "> <img src="../assets/img/flags/li.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Norway' "> <img src="../assets/img/flags/no.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Lithuania' "> <img src="../assets/img/flags/lt.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Luxembourg' "> <img src="../assets/img/flags/lu.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Romania' "> <img src="../assets/img/flags/ro.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Moldova' "> <img src="../assets/img/flags/md.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Slovakia' "> <img src="../assets/img/flags/sk.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Slovenia' "> <img src="../assets/img/flags/si.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Austria' "> <img src="../assets/img/flags/at.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Latvia' "> <img src="../assets/img/flags/lv.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'United Kingdom' "> <img src="../assets/img/flags/gb.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Malta' "> <img src="../assets/img/flags/mt.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Cyprus' "> <img src="../assets/img/flags/cy.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Bulgaria' "> <img src="../assets/img/flags/bg.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Iceland' "> <img src="../assets/img/flags/is.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Serbia' "> <img src="../assets/img/flags/rs.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Belgium' "> <img src="../assets/img/flags/be.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Ukraine' "> <img src="../assets/img/flags/ua.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Switzerland' "> <img src="../assets/img/flags/ch.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Italy' "> <img src="../assets/img/flags/it.png" width="30px" class="flag-icon"> </div>
                      <div v-else-if="row.name === 'Portugal' "> <img src="../assets/img/flags/pt.png" width="30px" class="flag-icon"> </div>
                      <!--- all v-else-if flags here -->
                      <div v-else> <img src="../assets/img/eu_flag.svg" width="30px" class="flag-icon"></div>
                   </td>
                   <td class="row-name">
                     {{row.name}}
                   </td>
                   <td class="row-trend">
                      <trend
                      :data = finalArray[index]
                      :gradient="['#20B2AA']"
                      auto-draw
                      smooth>
                      </trend>
                      <!--- all v-else-if flags here -->
                      <!-- <div v-else> <img src="../assets/img/eu_flag.svg" width="30px" class="flag-icon"></div> -->
                   </td>
                   <td class="row-percent">
                      <span id="percent" v-if="round(100/(Catalogues_Sum/row.stats[row.stats.length-1].count),4) == 0">  {{round(100/(Catalogues_Sum/row.stats[row.stats.length-1].count),100)}}&nbsp;%  </span>
                     <span v-else>
                      <span id="percent">{{round(100/(Catalogues_Sum/row.stats[row.stats.length-1].count),4)}}&nbsp;%  </span>
                      </span>
                     <div class="progress" style="height: 5px;">
                             <div class="progress-bar" role="progressbar" :style="'width:'+100/(Catalogues_Sum/row.stats[row.stats.length-1].count) +'%'"> </div>
                     </div>
                   <td class="row-number">
                       {{row.stats[row.stats.length-1].count.toLocaleString('fi')}}
                   </td>
                   <!-- <td class="row-updated">
                     {{row.stats[0].date}}
                   </td> -->
                </tr>
            </tbody>
    </table>
  </div>
</template>

<script>
import axios from 'axios'
import Vue from 'vue'
import Trend from 'vuetrend'

Vue.use(Trend)
/* eslint-disable */
export default {
  name: 'Countries',
  data () {
    return {
      loaded: false,
      chartdata: [10, 20],
      Catalogues_Sum: '',
      Catalogues_Sum_manuel: 838542,
      Catalogues: [],
      loading: true,
      desc: ['yes', 'no', 'unknown'],
      data: [],
      showError: false,
      errorMessage: 'No Data availale.',
      name: 'name',
      CountryCount: 'CountryCount',
      ascending: true,
      sortColumn: 'name',
      isActive: false,
      isLoading: true,
      finalArray: [],
      hope: [],
      count_dummy: []
    }
  },
  mounted () {
    if (this.$route.params.package) {
      this.loading = true
      this.package = this.$route.params.package
    }
  },
  methods: {
    sortTable: function (x) {
      if (this.sortColumn === x) {
        this.ascending = !this.ascending
      } else {
        this.ascending = false
        this.sortColumn = x
      }
      var ascending = this.ascending
      this.Catalogues.sort(function (a, b) {
        if (a[x] > b[x]) {
          return ascending ? 1 : -1
        } else if (a[x] < b[x]) {
          return ascending ? -1 : 1
        }
        return 0
      })
    },
    sortTableStart: function (x) {
      if (this.sortColumn === x) {
        this.ascending = this.ascending
      } else {
        this.ascending = false
        this.sortColumn = x
      }
      var ascending = this.ascending
      this.Catalogues.sort(function (a, b) {
        if (a[x] > b[x]) {
          return ascending ? 1 : -1
        } else if (a[x] < b[x]) {
          return ascending ? -1 : 1
        }
        return 0
      })
    },
    addSortableCountryCount (arr) {
      for (var x = 0; x < arr.length; x++) {
        Vue.set(this.Catalogues[x], 'CountryCount', +this.Catalogues[x].stats[this.Catalogues[1].stats.length-1].count)
      }
      return arr
    },
    addLabels () {
      for (var i = 0; i < this.Catalogues.length; i++){
        for (var l = 0; l < this.Catalogues[i].stats.length; l++) {
            this.count_dummy.push(+this.Catalogues[i].stats[l].count)   //+ macht aus String zahl
        }
      }
      this.hope.push(this.count_dummy)
        for (i = 0; i < this.count_dummy.length ; i +=  this.Catalogues[0].stats.length) {
            this.finalArray.push(this.count_dummy.slice(i, i+this.Catalogues[0].stats.length));
      }
      for (var l = 0; l < this.Catalogues[0].stats.length; l++) {
        this.date_dummy.push(this.Catalogues[0].stats[l].date)
      }
    },
    round (zahl, nStelle) {
      zahl = (Math.round(zahl * nStelle) / nStelle)
      return zahl
    },
    requestData () {
      axios.get(this.$env.ROOT_API + '/data/ds-per-country?list=true', { // http://odp-lic.ppe-aws.europeandataportal.eu:9090/data/ds-per-catalogue'
      })
        .then(response => {
          this.Catalogues = response.data.result
          this.Catalogues_Sum = response.data.sum
          this.loaded = true
          this.loading = false
          this.sortTableStart(this.name)
          this.$emit('changeLoading', this.loading)
          this.addSortableCountryCount(this.Catalogues)
          this.addLabels()
        })
        .catch(err => {
          this.errorMessage = err.response.data.error
          this.showError = true
        })
    },
    isMobile () {
      if (/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
        return true
      } else {
        return false
      }
    },
    isExplorer () {
      if (navigator.userAgent.indexOf('MSIE ') > -1 || navigator.userAgent.indexOf('Trident/') > -1 || window.navigator.userAgent.indexOf('Edge') > -1) {
        //  alert ('It is InternetExplorer')
        return true
      } else {
        //  alert('It is NOT InternetExplorer')
        return false
      }
    }
  },
  computed: {
  },
  Filters: {
    addPercentage: function (value) {
      return this.value + '%'
    }
  },
  created: function () {
    this.requestData()
  }
}
</script>

<style>

#detail-table{
  margin-top:25px;
}

.total-number{
  padding-left: 5px;
  margin-bottom: 10px;
  float: right;
}

.total-sum{
  font-weight: 500;
  background-color: #cddbe8;
  padding: 5px;
  border-radius: 1.875rem;
  min-width: 100px;
  display: block;
  min-height: 33px;
}

.active-table-head{
  text-decoration:underline;
}

.active{
   text-decoration: none;
}
.down {
  border: solid black;
  border-width: 0 1px 1px 0;
  display: inline-block;
  padding: 2px;
  transform: rotate(45deg);
  -webkit-transform: rotate(45deg);
  margin-bottom:3px
}
.up {
  border: solid black;
  border-width: 0 1px 1px 0;
  display: inline-block;
  padding: 2px;
  transform: rotate(-135deg);
  -webkit-transform: rotate(-135deg);
  margin-bottom:1px
}

.table-img {
  cursor: pointer;
  text-align: left;
  width: 100px;
}
.table-name {
  cursor: pointer;
  text-align: left;
  width: 450px;
}
.table-trend {
  cursor: pointer;
  text-align: center;
  width: 150px;
  padding-right: 20px !important;
}
.table-percent {
  cursor: pointer;
  text-align: left;
  width: 160px;
}
.table-number {
  cursor: pointer;
  text-align: center;
  width: 150px;
}
.table-updated {
  cursor: pointer;
  text-align: left;
  width: 110px;
}

.row-img {
  text-align: left;
  width: 100px;
}
.row-name {
  text-align: left;
  width: 450px;
}
.row-trend {
  text-align: left;
  width: 150px;
  padding-right: 20px !important;
}
.row-percent {
  text-align: left;
  width: 160px;
}
.row-number {
  text-align: center;
  width: 150px;
}
.row-updated {
  text-align: left;
  width: 110px;
  font-size: 15px;
}

.hide{
  visibility: hidden;
  font-size: 0px;
}

  .flag-icon{
    width: 25px;
    border-radius: 50%;
    margin-right: 14px;
    margin-left: 20px;
  }

  .progress-bar {
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
    -webkit-box-orient: vertical;
    -webkit-box-direction: normal;
    -ms-flex-direction: column;
    flex-direction: column;
    -webkit-box-pack: center;
    -ms-flex-pack: center;
    justify-content: center;
    color: #fff;
    text-align: center;
    white-space: nowrap;
    background-color: #3B6AA0;
    -webkit-transition: width 0.6s ease;
    transition: width 0.6s ease;
}

 #percent {
    text-align: center;
    color: #000;
    margin-right: 135px;
    font-size: 16px;
  }

  #less{
    font-size: 12px;
    color: darkgrey;
  }

  #sticky {
  background-color: #fff !important;
  background: solid;
  min-width: 952px !important;
}

</style>
